/*
 * CRXThread.h
 */

#ifdef _WIN32
# include <windows.h>
# include <process.h>
# define CRX_THREAD_TYPE	void
#else
# include <pthread.h>
# define CRX_THREAD_TYPE	void *
#endif

typedef CRX_THREAD_TYPE (* CRX_THREAD_CALLBACK) (void *);

class CRXThread
{
private:
	bool						mIsRunnable;

	CRX_THREAD_CALLBACK			mCallback;
	void						* mThreadArg;

public:
	CRXThread					(void);
	~CRXThread					(void);

public:
	void			Create		(void);

	virtual int		Run			(void);
	void			Stop		(void);
	inline void		SetRunnable	(bool aIsRunnable);
	inline bool		IsRunnable	(void) const;
};


